package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryPaymentDirectionDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryPaymentDirectionDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.friday.custody.dao.DataDictionaryPaymentDirectionDao;
import com.friday.custody.entity.DataDictionaryPaymentDirectionEntity;
import com.friday.custody.service.basicService.DataDictionaryPaymentDirectionService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryPaymentDirectionService")
@Slf4j
public class DataDictionaryPaymentDirectionServiceImpl extends ServiceImpl<DataDictionaryPaymentDirectionDao, DataDictionaryPaymentDirectionEntity>
        implements DataDictionaryPaymentDirectionService, DataDictionaryBasicService {


    @Autowired
    private DataDictionaryPaymentDirectionDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryPaymentDirectionEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryPaymentDirectionDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryPaymentDirectionDetailsEntity::getOriginValue, DataDictionaryPaymentDirectionDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryPaymentDirectionEntity::getId, DataDictionaryPaymentDirectionEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryPaymentDirectionDetailsEntity 查询失败！trustNo:{}",trustNo);
            }
        } else {
            log.error("DataDictionaryPaymentDirectionEntity 查询失败 trust:{}",trustNo);
        }
        return result;
    }
    @Override
    public R queryData(String type) {
        List<DataDictionaryPaymentDirectionEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryPaymentDirectionEntity::getKeyStr
                            ,DataDictionaryPaymentDirectionEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}